/* WARNING: This file was automatically generated from ants/Application.Java DO NOT EDIT *//* 
 *  $Id: Application.Java,v 1.2 1998/05/29 06:00:40 gback Exp $
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */


package ants ;

import utils .*;


/**
 * shell of an application of a node
 *
 * @author David Wetherall
 */


public abstract class Application
  extends ManagedObject
  implements Runnable
{
  final public static String[] defaults = { "-port", "0" };

  private Node server;
  private int serverAddress;

  final private static int DEFAULTRLIMIT = 64;
  private int rlimit;

  public int getDefaultResources() {
    return rlimit;
  }

  public void setDefaultResources(int r) {
    rlimit = r;
  }

  public Node thisNode() { return server; }

  protected short port;

  public boolean send(Capsule cap, int resources) {
    cap.prime(serverAddress, resources);
    return server.send(cap);
  }
  
  public boolean send(Capsule cap) {
    cap.prime(serverAddress, rlimit);
    return server.send(cap);
  }
  
  public void receive(Capsule cap) {
    // Log("Application.receive() got " + cap);
  }
  
  public void attachNode(Node s) throws Exception {
    if (server != s) {
      server = s;
      serverAddress = s.getAddress();
      server.attachApplication(this, port);
    }
  }
  
  public void run() {
    // this app is driven only by gui events and receive
  }
  
  public void setArgs(KeyArgs k) 
    throws Exception
  {
    k.merge(defaults);

    for (int i = 0; i < k.length(); i++) {
      if (k.key(i).equals("-port")) {
	port = (short)Integer.parseInt(k.arg(i));
	k.strike(i);
      }
    }
    
    super.setArgs(k);
  }
  
  public Application() {
    super();
    rlimit = DEFAULTRLIMIT;
  } 

  public Application(Manager b, String n) {
    super(b, n);
    rlimit = DEFAULTRLIMIT;
  } 
}


