/* 
 *  $Id: ChannelAddress.Java,v 1.3 1998/05/29 20:51:46 gback Exp $
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */


package ANTS_PKG;
import NODEOS_PKG.*;

import java.net.*;

/**
 * shell of singlecast address of a channel
 *
 * @author David Wetherall
 */

public abstract class ChannelAddress {

  /**
   * switches on format of address to create a subclass
   */

  public static ChannelAddress New(String addr)
    throws Exception
  {
    int count = 0;
    int pos = 0;

    // count the colons
    while ((pos = addr.indexOf(':', pos)) > 0) {
      count++; pos++;
    }
    
    if (count == 1) {
      return new UDPChannelAddress(addr);
    } else {
      throw new Exception("unrecognized address type " + addr);
    }
  }
  
  public static void main(String[] args) 
    throws Exception
  {
    String[] h = { "localhost:8000", "18.31.0.126:4096" };

    for (int i = 0; i < h.length; i++) {
      ChannelAddress n = ChannelAddress.New(h[i]);
      String s = n.toString();
      System.out.println(h[i] + " -> " + s);
    }
  }
}

