/* WARNING: This file was automatically generated from ants/Entity.Java DO NOT EDIT *//* 
 *  $Id: Entity.Java,v 1.4 1998/05/29 06:00:48 gback Exp $
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */


package ants ;

import java.util.Date;
import utils .*;


/**
 * Shell of the entities in that are combined to produce a running 
 * node configuration.  
 *
 * @author David Wetherall
 */


abstract class Entity
{
  final public static String[] defaults = { "-log", "0" };

  /**
   * Switch to control overall logging.  If false, we expect log calls
   * to be removed at compile-time by dead-code elimination and inlining
   */

  final static boolean LOGGING = true;
  final static public int[] L = { 1, 2, 4, 8, 16, 32, 64, 128 };
  final static int LOG_LEVELS = L.length;

  /** Vector of bit flags for configurable logging. Starts disabled. */
  protected int logLevel = 0;

  /** Only settable if we are logging */
  public void setLogLevel(int l) { if (LOGGING) logLevel = l; }
  public int getLogLevel() { return logLevel; }
  
  /** Report an event to our manager if relevant. */
  abstract protected void log(int level, String msg);
  
  private String name;
  public String getName() { return name; }
  public void setName(String n) { name = n; }

  private static String stamp() {
    Date d = new Date();
    return d.toString().substring(4, 20);
  }

  public static void error(String msg) {
    flushmsg();
    System.err.println(stamp() + "TERMINATING WITH ERROR-- " + msg);
    new Throwable(msg).printStackTrace();
    System.exit(1);
  }

  public static void warn(String msg) {
    flushmsg();
    System.err.println(stamp() + "WARNING-- " + msg);
  }

  private static String lastmsg = "";
  private static int repeat = 0;

  private static void flushmsg() {
    if (repeat > 0) {
      if (repeat == 1) {
	System.err.println(stamp() + lastmsg);
      } else {
	int pow = repeat;
	while ((pow % 2) == 0) { pow = pow / 2; }
	if (pow != 1) {
	  System.err.println(stamp() + "Last message repeated " +
			     repeat + " times");
	}
      }
    }
    lastmsg = "";
    repeat = 0;
  }
  
  public static void info(String msg) {
    if (msg.equals(lastmsg)) {
      repeat++;
      if (repeat > 1) {
	int pow = repeat;
	while ((pow % 2) == 0) { pow = pow / 2; }
	if (pow == 1) {
	  System.err.println(stamp() + "Last message repeated " +
			     repeat+" times");
	}
      }
    } else {
      flushmsg();
      lastmsg = msg;
      System.err.println(stamp() + msg);
    }
  }

  final static boolean ASSERTING = true;

  protected static void assert(boolean ok, String msg) {
    if (ASSERTING && !ok) error(msg);
  }

  protected void finalize() throws Throwable {
    super.finalize();
    // a chance to dump statistics, profile info, etc.
  }
  
  //
  // usage is waiting for reflection in 1.1 ...
  //
  //  public String usage()
  //    throws Exception
  //  {
  //  Class top = getClass();
  //  Class base = Class.forName("ants.Entity");
  //  KeyArgs k = new KeyArgs(defaults);
  //
  //    String us = top.getName() + ": ";
  //    while (top != base) {
  //      try {
  //	if (((top)this).defaults != null)
  //	  k.merge(((top)this).defaults);
  //      } catch (NoSuchFieldError e) {
  //      }
  //      top = top.getSuperclass();
  //    }
  //    return us + k.toString();
  //  }
  
  public void setArgs(KeyArgs k) 
    throws Exception 
  {
    k.merge(defaults);

    for (int i = 0; i < k.length(); i++) {
      if (k.key(i).equals("-log")) {
	setLogLevel(Integer.parseInt(k.arg(i)));
	k.strike(i);
      }
    }

    k.compact();
    if (k.length() > 0) throw new Exception("leftover keyargs: " + k);
  }
  
  public void setArgs(String[] ka) 
    throws Exception 
  {
    setArgs(ka, 0);
  }
  
  public void setArgs(String[] ka, int sk)
    throws Exception
  { 
    setArgs(new KeyArgs(ka, sk));
  }

  public void start()
    throws Exception 
  {
  }

  /** No-argument constructor if called through newInstance */
  public Entity() { super(); }

  /** Normal construction gives entity a name */
  public Entity(String t) { this(); setName(t); }

}


