/* 
 *  $Id: RouteEntry.Java,v 1.2 1998/05/29 06:00:55 gback Exp $
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */


package ANTS_PKG;

import java.net.*;

/**
 * a single entry of route table
 *
 * @author David Wetherall
 */

public class RouteEntry {
  public int dst;
  public int nxt;
  public ChannelAddress addr;
  public int cost;
  public long expires;
  public boolean change;

  public RouteEntry(int d, int n, ChannelAddress a)
  {
    super();
    dst = d;
    nxt = n;
    addr = a;
  }  

  public RouteEntry(String d, String n, String a)
    throws Exception
  {
    super();
    dst = NodeAddress.fromString(d);
    nxt = NodeAddress.fromString(n);
    addr = ChannelAddress.New(a);
  }  
}
