/* WARNING: This file was automatically generated from ants/TypeID.Java DO NOT EDIT *//* 
 *  $Id: TypeID.Java,v 1.3 1998/05/29 06:00:57 gback Exp $
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */


package ants ;

import java.util.*;
import utils .*;


/**
 * Capsule, Method, CodeGroup and Protocol identifiers.
 * This class wraps 128 bit MD5 hashes stored in byte arrays.
 *
 * @author David Wetherall
 */

public final class TypeID {

  /** We only use the first 16 bytes (128 bits) */
  private byte[] bits;

  public int hashCode() {
    return ((bits[0] + bits[4] + bits[8] + bits[12]) << 24) +
      ((bits[1] + bits[5] + bits[9] + bits[13]) << 16) +
      ((bits[2] + bits[6] + bits[10] + bits[14]) << 8) +
      (bits[3] + bits[7] + bits[11] + bits[15]);
  }
  
  public boolean equals(Object obj) {
    try {
      TypeID t = (TypeID)obj;

      for (int i = 0; i < 16; i++)
	if (bits[i] != t.bits[i]) return false;
      
      return true;
    } catch (Exception e) {
      return false;
    }
  }

  /** Known TypeIDs in cannonical form */
  private static Hashtable interned = new Hashtable();

  /** Intern a TypeID and return its cannonical value */
  public TypeID intern() {
    TypeID t = (TypeID)interned.get(this);
    if (t != null) return t;
    interned.put(this, this);
    return this;
  }

  /**
   * Compare two TypeIDs
   * 
   * @returns -1 (this < t), 0 (this.equals(t), 1 (this > t)
   */

  public int compare(TypeID t) {
    for (int i = 0; i < 16; i++) {
      if ((bits[i]&0xFF) > (t.bits[i]&0xFF)) return 1;
      else if ((bits[i]&0xFF) < (t.bits[i]&0xFF)) return -1;
    }
    return 0;
  }

  /**
   * Sort a vector of TypeIDs, ranking them with the compare method.
   * Good for short vectors only -- implemented with insertion sort.
   */

  public static void sortVector(Vector ids) {
    for (int j = 1; j < ids.size(); j++) {
      TypeID key = (TypeID)ids.elementAt(j);
      int i = j-1;

      while ((i >= 0) && (((TypeID)ids.elementAt(i)).compare(key) == 1)) {
	ids.setElementAt(ids.elementAt(i), i+1);
	i--;
      }
      ids.setElementAt(key, i+1);
    }
  }
  
  public String toString() {
    return MD5.toString(bits);
  }

  
  private TypeID() { }

  /**
   * Construct and initialize by shallow copy. The different notation
   * is meant to emphasize that a complete object is not being created
   * but rather an existing object is being packaged for convenience.
   */ 
  public static TypeID wrap(byte[] buf) {
    TypeID t = new TypeID();
    t.bits = buf;
    return t;
  }

  /** Unwrap, returning the inner byte array */
  public byte[] unwrap() {
    return bits;
  }

  /** Construct and initialize by deep copy */ 
  public TypeID(byte[] buf, int offset) {
    bits = new byte[16];
    System.arraycopy(buf, offset, bits, 0, 16);
  }

}

