package apps;

import java.awt.*;

import ants.*;
import utils.*;

/**
 * test GUI application with ping buttons
 *
 * @author David Wetherall
 */

public class DataClientApplication extends Application
{
  final public static String[] defaults = { "-delay", "0" };
  int target, delay, rTotCount = 0, thruInterval = 100;
  final int oneLess = 99;
  long beginTime;
  
  synchronized public void receive(Capsule cap) {
    super.receive(cap);

    if (cap instanceof DataCapsule) {
      switch ((rTotCount % thruInterval)) {
	//case 0:
	//beginTime = System.currentTimeMillis();
	//break;
      case oneLess:
	double diff = 
	  (double) (System.currentTimeMillis() - beginTime) / 1000.0;
	double thru = ((double) thruInterval) / diff;
	beginTime = System.currentTimeMillis();
	System.out.println("Received the " + (rTotCount + 1) + "th capsule");
	System.out.println("Throughput for last " + thruInterval + 
			   " capsules is " + thru + " caps/sec");
	System.out.flush();
	break;
      }
      
      rTotCount++;
    }
  }
  
  public void setArgs(KeyArgs k) 
    throws Exception
  {
    k.merge(defaults);

    for (int i = 0; i < k.length(); i++) {
      if (k.key(i).equals("-target")) {
	target = NodeAddress.fromString(k.arg(i));
	k.strike(i);
      } else if (k.key(i).equals("-delay")) {
	delay = Integer.parseInt(k.arg(i));
	k.strike(i);
      }
    }

    super.setArgs(k);
  }

  public void start() 
    throws Exception 
  {
    thisNode().register(new NullDataProtocol());
  }

  public DataClientApplication() 
    throws Exception 
  {
    super();
    beginTime = System.currentTimeMillis();
  }
}









