 /* 
  *  $Id: NullDataCapsule.java,v 1.1.1.1 1998/02/24 04:07:34 gback Exp $
  *  
  *  Copyright 1996 Massachusetts Institute of Technology
  * 
  *  Permission to use, copy, modify, distribute, and sell this software and
  *  its documentation for any purpose is hereby granted without fee, provided
  *  that the above copyright notice appear in all copies and that both that
  *  copyright notice and this permission notice appear in supporting
  *  documentation, and that the name of M.I.T. not be used in advertising or
  *  publicity pertaining to distribution of the software without specific,
  *  written prior permission.  M.I.T. makes no representations about the
  *  suitability of this software for any purpose.  It is provided "as is"
  *  without express or implied warranty.
  * 
  */


package apps;

import ants.*;

 /**
  * Null data capsule.  This is a data capsule with a different type
  * so it will be demand loaded. Useful for measuring the "null rpc".
  *
  * @author David Wetherall
  */

public class NullDataCapsule
   extends DataCapsule
{
  final private static byte[] MID = findMID("apps.NullDataCapsule");
  protected byte[] mid() { return MID; }
  
  final private static byte[] PID = findPID("apps.NullDataCapsule");
  protected byte[] pid() { return PID; }
  
  public NullDataCapsule() { }
  
  public NullDataCapsule(short sa, short da, int na, ByteArray d) {
    super(sa, da, na, d);
  }
}

