/* 
 *  $Id: AuctionProtocol.java,v 1.1.1.1 1998/02/25 00:06:15 gback Exp $
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */

package auction;

import ants.*;


/**
 * Auction protocol definition
 *
 * @author David Wetherall
 */

public class AuctionProtocol extends Protocol {
  
  public AuctionProtocol() throws Exception {
    startProtocolDefn();

    startGroupDefn();
    addCapsule("auction.AuctionFilterCapsule");
    endGroupDefn();

    startGroupDefn();
    addCapsule("auction.AuctionBidCapsule");
    addCapsule("auction.AuctionAckCapsule");
    endGroupDefn();

    endProtocolDefn();
  }
}






