/*
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries reproduce
 * the notices in supporting documentation, and (3) neither the name of the
 * University nor the Flux Group may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 * 
 * THE UNIVERSITY OF UTAH AND THE FLUX GROUP ALLOW FREE USE OF THIS SOFTWARE
 * IN ITS "AS IS" CONDITION, AND DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY
 * DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * The University requests users to return to flux-dist@cs.utah.edu any
 * improvements that they make and grant the University redistribution rights.
 */

/*
 * This file contains preprocessor definitions that are used when
 * preprocessing .Java files.
 */
/*
 * This ants is running in user-mode
 */
#define USERMODESIM	1

/*
 * Package names.  
 *
 * Using #defines allows packages to be used under a different name, 
 * if so desired.  It also allows the exchange of a different package with
 * the same functionality, without using CLASSPATH.
 *
 * We define _S version for string literals.
 */
#define ANTS_PKG 		ants
#define ANTS_PKG_S 		"ants"
#define NODEOS_PKG		nodeos
#define NODEOS_PKG_S		"nodeos"
#define UTILS_PKG		utils
#define UTILS_PKG_S		"utils"
#define WRAPPER_PKG		ants.wrapper
#define WRAPPER_PKG_S		"ants.wrapper"

/*
 * helper macros
 */
#define MAKESTRING(x)	"x"
#define DEBUG(x)	System.out.println(x)

/*
 * conversion macros
 */
#define UNSIGNED_BYTE2INT(x)	((x) & 0xff)

#define UNSIGNED_SHORT2INT(x)	((x) & 0xffff)

#define EXTRACT_SHORT(array, offset) 			\
	(UNSIGNED_SHORT2INT(				\
	 (UNSIGNED_BYTE2INT(array[(offset)]) << 8) | 	\
	 (UNSIGNED_BYTE2INT(array[(int)(offset)+1]))))

#define EXTRACT_INT(array, offset) 				\
	((UNSIGNED_BYTE2INT(array[(offset)]) << 24) | 		\
	 (UNSIGNED_BYTE2INT(array[(offset) + 1]) << 16) | 	\
	 (UNSIGNED_BYTE2INT(array[(offset) + 2]) << 8) | 	\
	 (UNSIGNED_BYTE2INT(array[(offset) + 3])))

