/* WARNING: This file was automatically generated from nodeos/CheckOneByteFlowHandle.Java DO NOT EDIT *//* 
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries reproduce
 * the notices in supporting documentation, and (3) neither the name of the
 * University nor the Flux Group may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 * 
 * THE UNIVERSITY OF UTAH AND THE FLUX GROUP ALLOW FREE USE OF THIS SOFTWARE
 * IN ITS "AS IS" CONDITION, AND DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY
 * DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * The University requests users to return to flux-dist@cs.utah.edu any
 * improvements that they make and grant the University redistribution rights.
 */

package nodeos ;

/**
 * A simple flow handle that checks the first byte against a constant
 * with which the handle is constructed.
 *
 * @author Godmar Back
 */
public class CheckOneByteFlowHandle extends FlowHandle
{
    private byte id;

    /**
     * Class constructor.
     * 
     * @param id	identification byte.
     * @param name	human-readable name.
     */
    public CheckOneByteFlowHandle(byte id, String name)
    {
	super(name);
	this.id = id;
    }

    /**
     * Check whether that buffer belongs to that flow.
     */
    public boolean checkBuffer(Buffer buf, int offset)
    {
	byte b[] = buf.getData();
	if (id == b[offset]) {
	    lastHeaderLength = 4;
	    return true;
	} else
	    return false;
    }
}

