/* WARNING: This file was automatically generated from nodeos/FlowManager.Java DO NOT EDIT *//* 
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries reproduce
 * the notices in supporting documentation, and (3) neither the name of the
 * University nor the Flux Group may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 * 
 * THE UNIVERSITY OF UTAH AND THE FLUX GROUP ALLOW FREE USE OF THIS SOFTWARE
 * IN ITS "AS IS" CONDITION, AND DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY
 * DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * The University requests users to return to flux-dist@cs.utah.edu any
 * improvements that they make and grant the University redistribution rights.
 */
package nodeos ;

/**
 * This class provides a set of methods to register flow handles
 * with the system.  This class is responsible for providing direct
 * access to the devices, or to higher layers of a coexisting protocol
 * stack.
 * <p>
 * Currently, only UDP is supported.
 *
 * @author Godmar Back
 *
 * @see FlowHandle
 */
import java.util.Hashtable;
import java.net.*;

public class FlowManager
{
    private Hashtable	udpFlows = new Hashtable();

    /** maximum datagram size for UDP */
    public static final int UDPMTU = 8192;

    /**
     * Register a flow dispatcher to receive UDP packets for
     * a given port.
     * <p>
     * In the current usermode implementation, this spawns of a separate
     * thread receiving packets on that port. These packets are then
     * dispatched to the flow dispatcher.
     *
     * @param port	UDP port to bind to.
     * @param fh	FlowDispatcher where packets are to be sent.
     */
    public DatagramSocket registerUDP(int port, FlowDispatcher fh)
    {

	Integer udpPort = new Integer(port);
	UDPFlowManager udpFlow =  (UDPFlowManager)udpFlows.get(udpPort);
	if (udpFlow == null) {
	    udpFlow = new UDPFlowManager(port, fh);
	    udpFlows.put(udpPort, udpFlow);
	}
	return udpFlow.getSocket();

    }
}

