/* WARNING: This file was automatically generated from nodeos/TestOBFlowHandle.Java DO NOT EDIT *//* 
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries reproduce
 * the notices in supporting documentation, and (3) neither the name of the
 * University nor the Flux Group may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 * 
 * THE UNIVERSITY OF UTAH AND THE FLUX GROUP ALLOW FREE USE OF THIS SOFTWARE
 * IN ITS "AS IS" CONDITION, AND DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY
 * DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * The University requests users to return to flux-dist@cs.utah.edu any
 * improvements that they make and grant the University redistribution rights.
 */
import nodeos .Buffer;
import nodeos .EmptyFlowHandle;
import nodeos .FlowHandle;
import nodeos .FlowManager;
import nodeos .SimpleFlowDispatcher;
import nodeos .CheckOneByteFlowHandle;
import nodeos .CheckOneWordFlowHandle;
import java.net.*;

public class TestOBFlowHandle implements Runnable 
{
    FlowHandle		fh;
    int			delay, 
			hlen,	/* header length */
			plen;	/* payload length */

    public TestOBFlowHandle(FlowHandle fh, int delay, int hlen, int plen)
    {
	this.fh = fh;
	this.delay = delay;
	this.hlen = hlen;
	this.plen = plen;
    }

    /* number of packet buffers initially allocated for that flow */
    final static int	CAPACITY = 5;

    public void run()
    {
	Buffer p;

	fh.addBuffers(CAPACITY, FlowManager.UDPMTU);
	while (true) {
	    p = fh.receive();
	    byte data[] = p.getData();
	    int pend = hlen + plen;

	    System.out.print(fh + " sees in [" + hlen + ".." + pend + "] {");
	    for (int i = hlen; i < plen+hlen; i++)
		System.out.print((( data[(int)p.getStart() + i] ) & 0xff)  
			+ ".");
	    System.out.println("} " + p);

	    /* recycle buffer */
	    fh.addBuffer(p);
	    try {
		Thread.sleep(delay);
	    } catch (InterruptedException ie) {}
	}
    }

    public static void main(String av[])
    {
	int IDENTICAL = Integer.parseInt(av[0]);

	FlowManager fm = new FlowManager();
	for (int port = 8000; port < 8002; port++) {
	    String pname = "port=" + (new Integer(port)).toString();

	    FlowHandle porthandle = new EmptyFlowHandle(pname);
	    fm.registerUDP(port, porthandle);

	    SimpleFlowDispatcher fd = new SimpleFlowDispatcher();

	    for (byte A = 0; A < 2; A++) {
		String aname = pname + " A=" + (new Integer(A)).toString();
		FlowHandle Ahandle = new CheckOneByteFlowHandle(A, aname);
		SimpleFlowDispatcher fda = new SimpleFlowDispatcher();
		fd.registerHandle(Ahandle);

		/* fire up an A handle */
		int delay = (int)(Math.random() * 1000);
		new Thread(new TestOBFlowHandle(Ahandle, delay, 4, 8)).start();

		for (int B = 0; B < 2; B++) {
		    String bname = aname + " B=" + (new Integer(B)).toString();
		    /* fire up three identical clones */
		    for (int i = 0; i < IDENTICAL; i++) {
			FlowHandle Bhandle = 
			    new CheckOneWordFlowHandle(B, bname + "/i=" + i);
			fda.registerHandle(Bhandle);

			delay = (int)(Math.random() * 1000);
			new Thread(new TestOBFlowHandle(Bhandle, delay, 4, 4)).
				start();
		    }
		}
		Ahandle.setPayloadDispatcher(fda);
	    }

	    porthandle.setPayloadDispatcher(fd);
	}
    }
}
