/* 
 *  $Id: Threads.Java,v 1.1.1.1 1998/02/24 04:07:37 gback Exp $
 *  
 *  Copyright 1996 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and
 *  its documentation for any purpose is hereby granted without fee, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */


package utils;


/**
 * Thread manipulating utilities
 *
 * @author David Wetherall
 */


public class Threads {


  /** List all groups and threads on System.out */
  public static void list() {
    ThreadGroup g = Thread.currentThread().getThreadGroup();

    // walk up the hierarchy to the system group
    while (g.getParent() != null) g = g.getParent();

    g.list();
  }    


  /** Test the class. */
  public static void main(String[] args) {
    list();
  }
}
